#include <stdio.h>
#include <string.h>
#include <curl/curl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

static size_t read_callback(void *ptr, size_t size, size_t nmemb, void *stream)
{
    size_t retcode;
    retcode = fread(ptr, size, nmemb, (FILE*)stream);

    return retcode;
}


int http_put(const char *url, const char  *file)
{
    CURL *easy_handle;
    CURLcode res;
    FILE * hd_src;
    int ret = 0;
    struct stat file_info;

    stat(file, &file_info);
    hd_src = fopen(file, "rb");
    curl_global_init(CURL_GLOBAL_ALL);
    easy_handle = curl_easy_init();

    if(easy_handle) 
    {
        curl_easy_setopt(easy_handle, CURLOPT_READFUNCTION, read_callback);
        curl_easy_setopt(easy_handle, CURLOPT_UPLOAD, 1L);
        curl_easy_setopt(easy_handle, CURLOPT_PUT, 1L);
        curl_easy_setopt(easy_handle, CURLOPT_URL, url);
        curl_easy_setopt(easy_handle, CURLOPT_READDATA, hd_src);
        curl_easy_setopt(easy_handle, CURLOPT_INFILESIZE_LARGE, (curl_off_t)file_info.st_size);
        curl_easy_setopt(easy_handle, CURLOPT_VERBOSE, 1); //打印出具体http协议字段

        res = curl_easy_perform(easy_handle);

        int HTTP_flag = 0;
        curl_easy_getinfo(easy_handle, CURLINFO_RESPONSE_CODE , &HTTP_flag);

        if(res != CURLE_OK)
        {
            fprintf(stderr, "curl_easy_perform() failed: %s\n", curl_easy_strerror(res));
            ret = -1;
        }

        curl_easy_cleanup(easy_handle);
    }

    fclose(hd_src); /* close the local file */ 
    curl_global_cleanup();

    return ret;
}


int main()
{
    char url[] = "http://10.10.19.51:8000/obj_detect?token=1111111111111111111";
    char file[] = "1.jpg";
    http_put(url, file);
}
